// -------------------------------------------------------------------------
//    @FileName             NFIBuffConfigModule.h
//    @Author               LvSheng.Huang
//    @Date                 2013-09-15
//    @Module               NFIBuffConfigModule
//
// -------------------------------------------------------------------------

#ifndef _NFI_BUFFCONFIG_MODULE_H
#define _NFI_BUFFCONFIG_MODULE_H

#include <iostream>
#include "NFILogicModule.h"

class NFIBuffConfigModule
    : public NFILogicModule
{

public:
    //
    enum BuffType
    {
        BT_BUFF,
        BT_DEBUFF,
    };

    //
    enum BuffSubType
    {
        //޸ֵԵ[BUFFΪֵDEBUFFΪֵ]
        BST_FIX_VALUE_PROPERTY,
        //޸ĿԵ[ߵȿ,BUFFΪֵDEBUFFΪֵһ㲻DEBUFFͿ]
        BST_FIX_CONTROL_PROPERTY,
        //һʱڹ(BUFFΪDEBUFFΪ)
        BST_FIX_ATK_COUNT,
    };

    //[ֵ㣬ٷֱȼ]
    enum BuffEffectValueType
    {
        EVT_ABSOLUTEVALUE,
        EVT_RATIO,
    };

    //ԭ[ԭĻHP MP֮ģҪԭ;ҪԭЩԣǹֵ統ǰѪЩѪЩҪԭ]
    enum BuffReverseType
    {
        ERT_NEED_REVERSE,
        ERT_NO_REVERSE,
    };

    //Ƿ
    enum BuffEffectClearOnDead
    {
        ECOD_SAVE,
        ECOD_CLEAR,
    };

    //Ƿ񱣴
    enum BuffDownSaveType
    {
        DST_NOSAVE,
        DST_SAVE,
    };

    class NFCBuffConfig
        : public NFMap<std::string, int>//[property->value]
    {
    public:
        std::string strConfig;

        BuffType BuffTypeValue;

        BuffSubType BuffSubTypeValue;

        //Buff飬ÿֻһͬŵBUFF
        int BuffGroupIDValue;

        //Ӱֵ ٷֱ ֵ--ǿԿأֻǾֵ ------ӰԱӦ[ǷҪأڰٷֱȺ;ֵԵ,Ȳ]
        BuffEffectValueType EffectValueTypeValue;

        //Ӱֵο[ǻֵأװֵеֵԷֲ]
        //EffectValueReferType EffectValueReferTypeValue;
        int EffectValueReferTypeValue;

        //ܹ
        int EffectTimeValue;

        //ÿμʱ0.5f
        float EffectTimeInterval;

        //ԭ
        BuffReverseType NeedReverseType;

        //Ƿ
        BuffEffectClearOnDead EffectClearOnDeadValue;

        //߱
        BuffDownSaveType DownSaveTypeValue;
    };

    //buffConfigManagerҪĿΪbuffĿΪЩǸݣÿβ㶼Ļ̫ģһ
    virtual NFCBuffConfig* GetBuffConfig(const std::string& strConfig) = 0;

};

#endif